mod Maux logic: 'cl'

incl Mtex

rem 
  \para \bf  Numeric functions.  \end 

fun/2 Max 'Tex_f2_pa_max'
  Max(x,y) = x <- x >= y
  Max(x,y) = y <- x < y

thm Max_comm
  Max(x,y) = Max(y,x)
proof 
 case Trich; x,y @ x1,y1; x1,y1; x1,y1
  proved
  proved
  proved..

fun/2 Exp 'Tex_f2_pa_exp'
  Exp(x,0) = 1
  Exp(x,y+1) = x*Exp(x,y)

thm Exp_zero
  Exp(x,y) = 0 <-> x = 0 & y > 0
proof 
 ind N; y @ 0; y
  proved
  split* x = 0 \/ x = 0 & y > 0 <-> x = 0.2,0,0
   split x = 0 \/ x = 0 & y > 0.4,0,0,0
    proved
    proved.
   proved...

thm Exp_one
  Exp(x,y) = 1 <-> x = 1 \/ y = 0
proof 
 ind N; y @ 0; y
  proved
  split* x = 1 & (x = 1 \/ y = 0) <-> x = 1.2,0,0
   proved
   proved...

thm Exp_plus
  Exp(x,y+z) = Exp(x,y)*Exp(x,z)
proof 
 ind N; y @ 0; y
  proved
  proved..

thm Exp_minus
  x > 0 & y >= z -> Exp(x,y-z) = Exp(x,y)/Exp(x,z)
proof 
 ind N; y; z @ 0; y
  proved
  case N; z @ 0; z1
   proved
   inst \a z(y >= z -> Exp(x,y-z) = Exp(x,y)/Exp(x,z)); z1 proved....

thm Exp_eq
  x > 1 -> Exp(x,y) = Exp(x,z) <-> y = z
proof 
 ind N; y; z @ 0; y
  use Exp_one.0; x; z proved.
  case N; z @ 0; z1
   proved
   inst \a z(Exp(x,y) = Exp(x,z) <-> y = z).0; z1 proved....

thm Exp_le
  x > 1 -> Exp(x,y) <= Exp(x,z) <-> y <= z
proof 
 ind N; y; z @ 0; y
  use Exp_zero.0; x; z proved.
  case N; z @ 0; z1
   use Exp_zero.0; x; y proved.
   inst \a z(Exp(x,y) <= Exp(x,z) <-> y <= z).0; z1 proved....

thm Exp_lt
  x > 1 -> Exp(x,y) < Exp(x,z) <-> y < z
proof 
 ind N; y; z @ 0; y
  cut z = 0
   proved
   use Exp_zero.0; x; z-1 proved..
  case N; z @ 0; z1
   use Exp_zero.0; x; y proved.
   inst \a z(Exp(x,y) < Exp(x,z) <-> y < z).0; z1 proved....

rem 
  \para \bf  List length.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

thm L_zero
  L(x) = 0 <-> x = 0
proof 
 case Ln; x @ 0; v,w
  proved
  proved..

thm L_conc
  L(x++y) = L(x)+L(y)
proof 
 ind Ln; x @ 0; v,w
  proved
  proved..

rem 
  \para \bf  List reversal.  \end 

fun Rev 
  Rev(0) = 0
  Rev(v,w) = Rev(w)++(v,0)

thm Rev_conc
  Rev(x++y) = Rev(y)++Rev(x)
proof 
 ind Ln; x @ 0; v,w
  proved
  proved..

